﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

const int N = 2e5 + 5;
vector<int> g[N];

const ll INF = 1e15;
ll dist[N];

int mx[N];


int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0);
	cin.tie(0);

	for (int i = 0; i < N; i++) {
		dist[i] = -INF;
		mx[i] = -1;
	}

	int n, m, k;
	cin >> n >> m >> k;

	set<int> st;

	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;

		g[a].push_back(b);
		g[b].push_back(a);
	}

	for (int i = 0; i < k; i++) {
		int p, h;
		cin >> p >> h;

		mx[p] = max(mx[p], h);
	}

	
	priority_queue<pll> pq;
	for (int i = 1; i <= n; i++) {
		if (mx[i] != -1) {
			dist[i] = mx[i];
			st.insert(i);
			pq.push({ mx[i], i });
		}
	}

	while (!pq.empty()) {
		auto j = pq.top();
		pq.pop();
		ll dst = j.first;
		ll ver = j.second;

		if (dst < dist[ver]) continue;

		for (auto i : g[ver]) {
			if (dist[i] < dist[ver] - 1) {
				dist[i] = dist[ver] - 1;
				pq.push({dist[i], i});
			}
		}
	}

	for (int i = 1; i <= n; i++) {
		if (dist[i] >= 0) {
			st.insert(i);
		}
	}

	cout << st.size() << '\n';

	for (auto i : st) {
		cout << i << ' ';
	}
}
