﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <cmath>
#include <iomanip>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

vector<char> ans;

void solve(int a, int b, pair<int, int> p1, pair<int, int> p2) {
	pair<int, int> know = make_pair(p1.first + p2.first, p1.second + p2.second);

	if (make_pair(a, b) == know) {
		return;
	}

	if (a * know.second < b * know.first) {
		ans.push_back('L');
		solve(a, b, p1, know);
	}
	else {
		ans.push_back('R');
		solve(a, b, know, p2);
	}
}

int evklid(int a, int b) {
	while (b != 0) {
		a %= b;
		swap(a, b);
	}

	return a;
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0);
	cin.tie(0);

	int a, b;
	cin >> a >> b;

	int g = evklid(a, b);

	a /= g;
	b /= g;

	ans.push_back('R');

	solve(a, b, make_pair(0, 1), make_pair(1, 0));

	for (auto i : ans) {
		cout << i;
	}
}
