﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <cmath>
#include <iomanip>

using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;


int evklid(int a, int b) {
	while (b != 0) {
		a %= b;

		swap(a, b);
	}

	return a;
}

double dist(pair<double, double> p1, pair<double, double> p2) {
	return sqrt((p1.first - p2.first) * (p1.first - p2.first) + (p1.second - p2.second) * (p1.second - p2.second));
}

int main() {
	ios_base::sync_with_stdio(false);
	cout.tie(0);
	cin.tie(0);

	int n;
	cin >> n;

	double x1, y1;
	cin >> x1 >> y1;

	double x2, y2;
	cin >> x2 >> y2;

	cout << fixed << setprecision(10) << dist(make_pair(x1, y1), make_pair(x2, y2));
}
